import numpy as np
import os

import util

import parser

def max_score():
    return 4

def timeout():
    return 60

def test():

    X_test,y_test = parser.file_reader("data/training_set.txt")

    X_sol = []
    y_sol = []
    #Read in correctly parsed dataset
    file = open("test_cases/Q3/parserX_grade.txt",'r')
    lines = file.readlines()
    for i in range(0,len(lines)):
        line = lines[i]
        line = line[0:len(line)-1]
        data = np.array(list(line.split(",")))
        y_sol.append(float(data[len(data)-1]))
        data = data[0:len(data)-1]
        X_sol.append(data.astype(np.float))

    X_sol = np.array(X_sol)
    y_sol = np.array(y_sol)

    for i in range(0,len(X_test)):
        for j in range(0,len(X_test[i])):
            assert X_sol[i][j] == X_test[i][j], "Parsing Error: " + str(X_sol[i][j]) + " is not " + "y_test" + str(X_test[i][j])
        assert y_sol[i] == y_test[i], "Parsing Error: " + str(y_sol[i]) + " is not " + "y_test" + str(y_test[i])

    test_score = max_score()
    test_output = 'PASS\n'

    return test_score, test_output

if __name__ == "__main__":
    test()
